#=================================VARIABLES==========================================


variables:
  DOCKER_REGISTRY_IMAGE: $DOCKER_REGISTRY/$DOCKER_IMAGE_FRONT

#=================================RULES============================================


.aws-deploy-production-rules: &aws-deploy-production-rules
  - if: $CI_COMMIT_BRANCH == "production"


#=================================STAGES: DEPLOY ============================================

get-production-version:
  stage: deploy
  image:
    name: alpine/git:v2.34.2
    entrypoint: [""]
  script:
    - echo PACKAGE_VERSION=$(git describe --abbrev=0 --tags | tr -d "v") > version.env
    - cat version.env
  artifacts:
    reports:
      dotenv: version.env
  rules:
    - *aws-deploy-production-rules


update-docker-production-tag:
  stage: deploy
  image: docker:20.10
  services:
    - docker:20.10-dind
  variables:
    DOCKER_TLS_CERTDIR: ""
    DOCKER_HOST: tcp://docker:2375
  before_script:
    - docker login -u $DOCKER_REGISTRY_USERNAME -p $DOCKER_REGISTRY_TOKEN
  resource_group: production
  script:
    - docker pull $DOCKER_REGISTRY_IMAGE:$PACKAGE_VERSION
    - docker tag $DOCKER_REGISTRY_IMAGE:$PACKAGE_VERSION $DOCKER_REGISTRY_IMAGE:production
    - docker push --all-tags $DOCKER_REGISTRY_IMAGE
  tags:
    - dind
  needs:
    - job: get-production-version
      artifacts: true
      optional: true
  rules:
    - *aws-deploy-production-rules


aws_deploy_production:
  stage: deploy
  variables:
    FRONT_IMAGE: $DOCKER_REGISTRY/$DOCKER_IMAGE_FRONT:$PACKAGE_VERSION
  trigger:
    project: "models8/pipeline-model-group/terraform-playbook-pipeline" #CAN'T USE VARIABLE HERE (DUE TO A BUG)
    branch:  "production"
    strategy: depend
  needs:
    - job: get-production-version
      artifacts: true
      optional: true
    - job: update-docker-production-tag
      optional: true
  rules:
    - *aws-deploy-production-rules


#----------------------- DESTROY STAGING WHEN PRODUCTION DEPLOYED ---------------------------------


shutdown-staging-aws:  #Parent-Child pipeline
  stage: destroy
  variables:
    FRONT_IMAGE: $DOCKER_REGISTRY_IMAGE:staging
    ACTION: destroy
  trigger:
    include:
      - project: $CI_PROJECT_NAMESPACE/terraform-playbook-pipeline
        ref: production
        file: "/ci-templates/trigger-modules/.gitlab-ci-deploy-staging.yml"
    strategy: depend
  rules:
    - *aws-deploy-production-rules

